import type { WatchOptions } from "chokidar";
import type { Options as ConnectHistoryApiFallbackOptions } from "connect-history-api-fallback";
import WebpackDevServer from "webpack-dev-server";
export interface WebSocketServerOptions {
    protocol?: string;
    host?: string;
    port?: number | string;
    prefix?: string;
    path?: string;
}
export declare type ProxyOptions = WebpackDevServer.ProxyConfigMap | WebpackDevServer.ProxyConfigArrayItem | WebpackDevServer.ProxyConfigArray;
export declare type ClientOptions = WebpackDevServer.ClientConfiguration | boolean;
export interface Dev {
    host?: string;
    port?: number | string;
    static?: {
        directory?: string;
        watch?: boolean | WatchOptions;
    };
    proxy?: ProxyOptions;
    devMiddleware?: {};
    hot?: boolean;
    open?: boolean;
    liveReload?: boolean;
    webSocketServer?: false | "sockjs" | "ws" | {
        type?: "sockjs" | "ws" | string | Function;
        options?: WebSocketServerOptions;
    } | Function;
    client?: ClientOptions;
    historyApiFallback?: boolean | ConnectHistoryApiFallbackOptions;
}
//# sourceMappingURL=devServer.d.ts.map