"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveOptimizationOptions = exports.getNormalizedOptimizationRuntimeChunk = void 0;
const splitChunks_1 = require("./splitChunks");
function getNormalizedOptimizationRuntimeChunk(runtimeChunk) {
    if (runtimeChunk === undefined)
        return undefined;
    if (runtimeChunk === false)
        return false;
    if (runtimeChunk === "single") {
        return {
            name: () => "runtime"
        };
    }
    if (runtimeChunk === true || runtimeChunk === "multiple") {
        return {
            name: entrypoint => `runtime~${entrypoint.name}`
        };
    }
    const { name } = runtimeChunk;
    return {
        name: typeof name === "function" ? name : () => name
    };
}
exports.getNormalizedOptimizationRuntimeChunk = getNormalizedOptimizationRuntimeChunk;
function resolveOptimizationOptions(op, mode) {
    var _a;
    return {
        moduleIds: (_a = op.moduleIds) !== null && _a !== void 0 ? _a : (mode === "production" ? "deterministic" : "named"),
        minimize: op.minimize,
        minimizer: op.minimizer,
        splitChunks: (0, splitChunks_1.resolveSplitChunksOptions)(op.splitChunks)
    };
}
exports.resolveOptimizationOptions = resolveOptimizationOptions;
//# sourceMappingURL=optimization.js.map